package gs.admin;

import java.util.Hashtable;

import java.io.IOException;

import javax.servlet.Servlet;
import javax.servlet.ServletException;
import javax.servlet.ServletOutputStream;
import javax.servlet.ServletContext;
import javax.servlet.ServletConfig;

import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpUtils;


import gs.db.update;
import gs.db.dbStudent;
import gs.db.dbCourse;
import gs.db.dbAssignment;
import gs.db.dbSurvey;

import gs.admin.gCourses;


import gs.html.Html;
import gs.html.Parser;
import gs.html.RecordParser;


/**
 */
public class gAssignments extends HttpServlet {

    /**
     * Assignment the request.
     *
     * @exception  ServletException if there is any sort of Exception
     *
     */
  public gSystem  sys=new gSystem();




  //||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||//
  // doPost  doGet
  //||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||//  
  public void doPost  (HttpServletRequest req,HttpServletResponse response) 
       throws IOException, ServletException 
  {
    processInOut( req,response);
  }

  public void doGet(HttpServletRequest req, HttpServletResponse response)
       throws IOException, ServletException
  {
    processInOut( req,response);
  }




  //||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||//
  // processInOut
  //||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||//  

  public void processInOut (HttpServletRequest req,HttpServletResponse response)
       throws IOException, ServletException
  {
    response.setStatus(HttpServletResponse.SC_OK); 
    response.setContentType("text/html");
    
    ServletOutputStream out = response.getOutputStream();
    String templateFile = req.getPathTranslated();
    String unum = req.getParameter("unum"); 
    String command = req.getParameter("comm"); 
    String course = req.getParameter("course"); 
    String assignid   = req.getParameter("assignid"); 

    //System.out.println( "AssignmentS");
    if (command==null) {
      return;
    }

    //System.out.println( "unum - - - > ["+unum+"]" );
    //System.out.println( "comm - - - > ["+command+"]" );

    try {
       if ( course==null || unum==null) {
	 String coursename  = req.getParameter("coursename");

	 if (coursename==null ||unum==null ) 
	   throw new Exception("State lost: Unknown course or user!.");
	 String term    = req.getParameter("term");
	 String year    = req.getParameter("year");
	 course=coursename+term+year;
       }
       sys.accessPermission(unum,course,"ASSIGNMENT_RECORDS:"+command);
       
       if (command.equals("MAIN"))
	 returnMainPage(out, unum, course, req.getPathTranslated());

       else if(command.equals("LIST")) 
	 listAssignments(out, unum, course, req.getPathTranslated(), false,"");
   
       else if(command.equals("LISTALL"))
	 listAssignments(out, unum, course, req.getPathTranslated(), true,"");

       else if(command.equals("NEW"))
	 newAssignment(out, unum, course, req.getPathTranslated());

       else if(command.equals("ADD")) 
	 addAssignment(out, unum, course, readAssignmentFields(req) , req.getPathTranslated());
       else if(command.equals("SHOW"))
	 browseAssignment(out, unum,  req.getParameter("assignid"), course, req.getPathTranslated(),"don't reload");



       else if(command.equals("SKIP"))
	 skip(out, unum, course, req.getPathTranslated());

       else if(command.equals("INFO"))
	 infoPage(out, unum, course, req.getPathTranslated());

       else if(command.equals("CANCEL")) 
	 out.println("<script language=JavaScript> history.go(-2);</script>");
       else if(command.equals("EDIT"))
	 editAssignmentRecord(out, unum,  req.getParameter("assignid"),  course, req.getPathTranslated());


	 else if(command.equals("DELETE"))
	   deleteAssignment(out, unum,  req.getParameter("assignid"), course, req.getPathTranslated(), (String)(req.getParameter("answer")));

	 else if(command.equals("UPDATE")) 
	   updateAssignment(out, unum, course, readAssignmentFields(req), req.getPathTranslated());
	 else if(command.equals("PUBLISH"))
	   publish(out, unum, req.getParameter("assignid") ,course, req.getParameter("publish") , req.getPathTranslated());


   
     } catch (Exception e) {
       //System.out.println( "Error catched. " );
       // if (e.getMessage()!=null)
	 //System.out.println( e.getMessage());
       //System.out.println( "ERROR CATCHED. " );
       sys.error(out,e);
       // e.printStackTrace();
       //sys.error(out,e.getMessage());
     }
     
     //    out.println( Html.footer() );
     out.close();
  
  }


  //--------------------------------------------------------------------//
  //Reads Assignment fields from the html request form
  //--------------------------------------------------------------------//
  public dbAssignment readAssignmentFields(HttpServletRequest req) throws Exception {

    dbAssignment u=new dbAssignment();
    String assignid   = req.getParameter("assignid"); 
      
    if(assignid.equals("") ) 
      throw new Exception("Please enter assignment id!");
   else {
      u.fields.put("course"     , req.getParameter("course"));
      u.fields.put("type"     , req.getParameter("type"));
      u.fields.put("grbase" , req.getParameter("grbase"));
      u.fields.put("weight" ,req.getParameter("weight"));
      u.fields.put("notes"      , req.getParameter("notes").replace('\'','`')); 
      u.fields.put("partials"       , req.getParameter("partials"));  
      u.fields.put("publish"       , req.getParameter("publish"));  
      u.fields.put("url"       , req.getParameter("url").replace('\n','\0'));  
      u.fields.put("commenturl"    , req.getParameter("commenturl"));  
      if (req.getParameter("oldassignid")==null)
	u.fields.put("oldassignid",assignid);
      else
	u.fields.put("oldassignid"  , req.getParameter("oldassignid"));
      
    }
    u.fields.put("assignid"     , assignid);    
    u.setIdentification();
    return u;

  }
 


  //--------------------------------------------------------------------//
  //returnMainPage(
  //--------------------------------------------------------------------//  
  void returnMainPage(ServletOutputStream out, String unum,String course, String templateFile)
       throws Exception, IOException 
  {
      Hashtable ht = new Hashtable();
      sys.globalValues(ht,unum);
      ht.put("course",course);
      Parser.parseHtml(templateFile,ht , out);
  }


  //--------------------------------------------------------------------//
  // List ALL assignments 
  //--------------------------------------------------------------------//  
  void listAssignments(ServletOutputStream out, String unum, String course, String templateFile, boolean allFields,String reload)
       throws Exception, IOException 
  {
      Hashtable ht = new Hashtable();
      sys.globalValues(ht,unum);
      ht.put("course",course);
      ht.put("reload",reload);
      dbAssignment dba = new dbAssignment(course);
      Parser.parseHtml(templateFile, ht, out,  new RecordParser(dba.listAssignments(allFields), dba.listAssignmentsFields(allFields)));
   }
  //--------------------------------------------------------------------//
  // info page
  //--------------------------------------------------------------------//  
  void infoPage(ServletOutputStream out, String unum,String course ,String templateFile) 
       throws Exception,IOException
  {
      Hashtable ht = new Hashtable();
      ht.put("course",course);
      sys.globalValues(ht,unum);
      Parser.parseHtml(templateFile,ht,out);
  }

  //--------------------------------------------------------------------//
  // Browse a assignment
  //--------------------------------------------------------------------//  
  void browseAssignment (ServletOutputStream out, String unum,String assignid ,String course, String templateDir,String reload) 
       throws Exception, IOException
  {
    //    if(assignid.length() >= gAssignments.MIN_LOGIN_NAME_LENGTH) {
      try {
	//Hashtable ht=dbAssignment.getFields( assignid );
	Hashtable ht=sys.asgn_cache.get(assignid,course).getFields();
	sys.globalValues(ht,unum);
	ht.put("course",course);
	ht.put("assignid",assignid);
	ht.put("reload",reload);
	if (ht.get("type").equals("A"))
	  ht.put("type_html","Assignment");
	else ht.put("type_html",ht.get("type"));
	Parser.parseHtml(templateDir+"browse.html",ht , out);
      
      } catch(Exception e) {
	throw new Exception("<h2>ERROR at browsing assignment "+assignid+": "+e.getMessage()+"</h2>");
      }
      // } else {
      // throw new Exception("<h2>ERROR:Illegal assignment login name '"+assignid+"'.</h2>");
      // }
  }

  //--------------------------------------------------------------------//
  // open new assignment page 
  //--------------------------------------------------------------------//  
  void newAssignment  (ServletOutputStream out, String unum,String course, String templateDir)
       throws  Exception, IOException
  {
     dbAssignment dba=new dbAssignment(course);
     String next= Integer.toString(dba.findMaxAI()+1);
     String grbase="";
     String optionstr="";
     dbCourse dbc=sys.crs_cache.get(course);
     String grtype=dbc.gradingType();
     //System.out.println("gradingTyadaBASEpe ===++>"+grbase);

     if (grtype.equals("customized")) {
       optionstr="Customized grades";
       grbase= "<select name=grbase><option>"+dbc.customizedGradesHtml()+"</select>";
     } else {
       optionstr="Numeric option selected";
       grbase= "<input name=grbase size=5 value=>";
     }
      Hashtable ht= new Hashtable();
      sys.globalValues(ht,unum);
      ht.put("course",course);
      ht.put("optionstr",optionstr);
      ht.put("next",next);
      ht.put("grbase",grbase);
      Parser.parseHtml(templateDir+"new.html", ht, out);
  }


   //--------------------------------------------------------------------//
  //  editAssignmentRecord page
  //--------------------------------------------------------------------//  
  void editAssignmentRecord (ServletOutputStream out, String unum, String assignid,String course, String templateDir)        
       throws  Exception, IOException
  {
    dbAssignment dba=sys.asgn_cache.get(assignid,course);
    //Hashtable ht=dbAssignment.getFields(assignid);
    Hashtable ht=dba.getFields();
    sys.globalValues(ht,unum);
    if (dba.fields.get("type").equals("A"))
      ht.put("type_html","Assignment");
    else ht.put("type_html",dba.fields.get("type"));
     String grbase=dba.gradingBase();
     String optionstr="";
     dbCourse dbc=sys.crs_cache.get(course);
     String grtype=dbc.gradingType();
     //System.out.println("gradingTyadaBASEpe ===++>"+grbase);
     //System.out.println("gradin+++-------------------"+dba.gradingBase());

     if (grtype.equals("customized")) {
       optionstr="Customized grades";
       grbase= "<select name=grbase><option>"+grbase+dbc.customizedGradesHtml()+"</select>";
     } else {
       optionstr="Numeric option selected";
       grbase= "<input name=grbase size=5 value="+grbase+">";
     }
    //System.out.println("gradin++++++++++++++++++++++++>"+grbase);
    //System.out.println("gradin++++++++++++++++++++++++>"+dba.gradingBase());
     String publish="<option>YES<option>NO";
     if (dba.fields.get("publish").equals("NO"))
       publish="<option>NO<option>YES";

     ht.put("publish_html",publish);
      ht.put("grbase_html",grbase);
      ht.put("optionstr",optionstr);
    ht.put("course",course);
    ht.put("oldassignid", assignid);
    Parser.parseHtml(templateDir+"edit.html", ht, out);

  }

  //--------------------------------------------------------------------//
  // DELETE a assignment
  //--------------------------------------------------------------------//  
  void deleteAssignment (ServletOutputStream out, String unum, String assignid,String course,String templateDir, String answer) 
       throws Exception, IOException
  {
    String templateFile=templateDir;;
      Hashtable ht = new Hashtable();
      sys.globalValues(ht,unum);
      ht.put("course",course);
      if(answer == null) {

	templateFile+="confirm.html";
	ht.put("message", "<br>Do you really want to delete the assignment <i>"+assignid+"</i>?");
	ht.put("actionurl", "updatemessage.html");
	ht.put("comm","DELETE");	
	ht.put("assignid",assignid);
      } 
      else if(answer.equals("YES")) {
	//dbAssignment.delete(assignid);
	sys.asgn_cache.delete(assignid,course);
	ht.put("message", "Assignment information has been succesfully deleted!");
      }
      else if(answer.equals("NO")) {
	out.println("<script language=JavaScript> history.go(-2);</script>");
      }
      Parser.parseHtml(templateFile, ht, out);
      
  }

  //--------------------------------------------------------------------//
  // add new Assignment
  //--------------------------------------------------------------------//  
  void addAssignment(ServletOutputStream out, String unum,String course, dbAssignment dbu, String templateFile )
       throws Exception,IOException
  {
    try {
      //dbu.add();
      sys.asgn_cache.add(dbu);
      browseAssignment(out, unum,dbu.assignid,course,templateFile,"reload");
	
    } catch( Exception e ) {
      String error =e.getMessage();
      if (error.indexOf("unique") >=0) {
	error= new String("This assignment login id exists in the system. <br> Please try another one.");
	}
      throw new Exception(error);
    }    
  }
  //--------------------------------------------------------------------//
  // update assignment record 
  //--------------------------------------------------------------------//  

  void updateAssignment(ServletOutputStream out, String unum,String course, dbAssignment dbu,String templateDir)
       throws Exception,IOException
    {
      try {
	Hashtable ht = new Hashtable();
	sys.globalValues(ht,unum);
	//	dbu.update();
	sys.asgn_cache.update(dbu);
      browseAssignment(out, unum,dbu.assignid,course,templateDir,"reload");
	
      } catch( Exception e ) {
	out.println( Html.header("Assignment Records") );
	String error =e.getMessage();
	if (error.indexOf("unique") >=0) {
	  error= new String("This assignment login id exists in the system. <br> Please try another one.");
	}
	throw new Exception(error);
      }   
    }
  //--------------------------------------------------------------------//
  // 
  //--------------------------------------------------------------------//  
  void skip(ServletOutputStream out, String unum,String course,String templateDir) 
       throws Exception,IOException
  {
      Hashtable ht = new Hashtable();
      sys.globalValues(ht,unum);
	ht.put("course",course);
      Parser.parseHtml(templateDir+"info.html",ht,out);
  }



  //--------------------------------------------------------------------//
  // ASSIGNMENT: 
  //--------------------------------------------------------------------//  
 
  void publish (ServletOutputStream out, String unum, String assignid,String course,String publish, String templateFile)        
       throws  Exception, IOException
  {
    dbAssignment dba=sys.asgn_cache.get(assignid,course);
    if (publish.equals("NO")) publish="YES";
    else publish="NO";
    dba.fields.put("publish",publish);
    dba.fields.put("oldassignid",assignid);    
    sys.asgn_cache.update(dba);  
    listAssignments(out, unum, course, templateFile, false,"INFOreload");
    out.println("<script language=JavaScript> history.go(-2); ");

  }





} //class close


