package gs.admin;

import java.util.Hashtable;

import java.io.IOException;
import    java.lang.Runtime;

import javax.servlet.Servlet;
import javax.servlet.ServletException;
import javax.servlet.ServletOutputStream;
import javax.servlet.ServletContext;
import javax.servlet.ServletConfig;

import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpUtils;


import gs.db.update;
import gs.db.dbUser;
import gs.db.dbStudent;

import java.sql.ResultSet;

import gs.html.Html;
import gs.html.Parser;
import gs.html.RecordParser;


/**
 */
public class gUsers extends HttpServlet {

    /**
     * Service the request.
     *
     * @exception  ServletException if there is any sort of Exception
     *
     */

  public static int MIN_LOGIN_NAME_LENGTH = 3;
  public static int MIN_PASSWORD_LENGTH = 3;
  public gSystem  sys=new gSystem();



  public void doPost  (HttpServletRequest req,HttpServletResponse response) 
       throws IOException, ServletException 
  {
    processInOut( req,response);
  }

  public void doGet(HttpServletRequest req, HttpServletResponse response)
       throws IOException, ServletException
  {
    processInOut( req,response);
  }


  public void processInOut (HttpServletRequest req,HttpServletResponse response)
       throws IOException, ServletException
  {

    response.setStatus(HttpServletResponse.SC_OK); 
    response.setContentType("text/html");
    
    ServletOutputStream out = response.getOutputStream();
    String templateFile = req.getPathTranslated();
    String unum = req.getParameter("unum"); 
    String command = req.getParameter("comm"); 
    //    out.println( Html.header("User Records") );
    //    System.out.println( templateFile);
    //    System.out.println( command );


    if (command == null ) 
      return;

    try {
      sys.accessPermission(unum,"ALL","USER_RECORDS:"+command);
      if (command.equals("MAIN"))
	returnMainPage(out, unum, req.getPathTranslated());
      else if(command.equals("list"))
	listUsers(out, unum, req.getPathTranslated(), false);

      else if(command.equals("LISTALL"))
	listUsers(out, unum, req.getPathTranslated(), true);

      else if(command.equals("FRAME"))
	decideFrame(out, unum, req.getPathTranslated(), 
		    req.getParameter("framecomm"),
		    req.getParameter("file"), req.getParameter("gslogin"));

      else if(command.equals("SHOW"))
	browseUser(out, unum, req.getPathTranslated(), req.getParameter("gslogin"));

      else if(command.equals("NEW"))
	newUserFrame(out, unum, req.getPathTranslated());

      else if(command.equals("NEWRECORD"))
	newUserRecord(out, unum, req.getPathTranslated());

      else if(command.equals("SKIP"))
	skip(out, unum, req.getPathTranslated());

      else if(command.equals("INFO"))
	infoPage(out, unum, req.getPathTranslated());

      else if(command.equals("CANCEL")) {
	//out.println("<script language=JavaScript> history.go(-1);</script>");
	decideFrame(out, unum, req.getPathTranslated(), 
		    "SHOW", 
		    "browse.html", req.getParameter("oldgslogin"));
      }
      else if(command.equals("EDIT"))
	editUserFrame(out, unum, req.getPathTranslated(),
		      (String)(req.getParameter("gslogin")));

      else if(command.equals("EDITRECORD"))
	editUserRecord(out, unum, req.getPathTranslated(),
		       (String)(req.getParameter("gslogin")));

      else if(command.equals("DELETE"))
	deleteUser(out, unum, req.getPathTranslated(),
		   (String)(req.getParameter("gslogin")), 
		   (String)(req.getParameter("answer")));

      else if(command.equals("UPDATE")) 
	updateUser(out, unum, readUserFields(req), req.getPathTranslated());

      else if(command.equals("ADD")) 
	addUser(out, unum, readUserFields(req), req.getPathTranslated());

    } catch (Exception e) {
      sys.error(out,e);
      //e.printStackTrace();
      //sys.error(out,e.getMessage());
    }

    //    out.println( Html.footer() );
    out.close();
  
  }


  //--------------------------------------------------------------------//
  //Reads User fields from the html request form
  //--------------------------------------------------------------------//
  public dbUser readUserFields(HttpServletRequest req) throws Exception {

    dbUser u=new dbUser();

    String gslogin   = req.getParameter("gslogin"); 
    String firstname = req.getParameter("firstname"); 
    String midname   = req.getParameter("midname");
    String lastname  = req.getParameter("lastname"); 
    String gspwd     = req.getParameter("gspwd"); 
    String confirm   = req.getParameter("confirmgspwd"); 
      
    if(gslogin.equals("") || firstname.equals("") || lastname.equals("") 
       || gspwd.equals("") || confirm.equals("")) 
      throw new Exception("Please enter in all the fields in red!");
    else if (gslogin.length() < gUsers.MIN_LOGIN_NAME_LENGTH) 
      throw new Exception("Users' login names must be at least"+MIN_LOGIN_NAME_LENGTH+" digits long!");
    else if (!gspwd.equals(confirm)) 
      throw new Exception("Passwords do not match!");
    else if (gspwd.length() < gUsers.MIN_PASSWORD_LENGTH) 
      throw new Exception("Password must be at least "+MIN_PASSWORD_LENGTH+" characters long!");
    else {
      u.fields.put("idnum"     , req.getParameter("idnum"));
      u.fields.put("privilige" , req.getParameter("privilige"));
      u.fields.put("ACL"       , req.getParameter("access"));
      u.fields.put("email"     , req.getParameter("email")); 
      u.fields.put("dept"      , req.getParameter("dept").replace('\'','`')); 
      u.fields.put("url"       , req.getParameter("url").replace('\n','\0'));  
      u.fields.put("picurl"    , req.getParameter("picurl").replace('\n','\0'));  
      u.fields.put("phone"     , req.getParameter("phone")); 
      u.fields.put("room"      , req.getParameter("room"));  
      u.fields.put("systemslogin"   , req.getParameter("systemslogin"));
      u.fields.put("comments"  , req.getParameter("comments").replace('\'','`'));
      try {u.fields.put("reserved"  , req.getParameter("reserved"));} 
      catch (Exception e) {}
      u.fields.put("oldgslogin"  , req.getParameter("oldgslogin"));
      
    }
    u.fields.put("gslogin"     , gslogin);    
    u.fields.put("firstname"   , firstname);    
    u.fields.put("midname"     , midname);    
    u.fields.put("lastname"    , lastname);    
    u.fields.put("gspwd"       , gspwd);    
    u.setIdentification();

    return u;

  }




  //--------------------------------------------------------------------//
  //returnMainPage(
  //--------------------------------------------------------------------//  
  void returnMainPage(ServletOutputStream out, String unum, String templateFile)
       throws Exception, IOException 
  {
      Hashtable ht = new Hashtable();
      sys.globalValues(ht,unum);
      Parser.parseHtml(templateFile,ht , out);
  }


  //--------------------------------------------------------------------//
  // List ALL users 
  //--------------------------------------------------------------------//  
  void listUsers(ServletOutputStream out, String unum, String templateFile, boolean allFields)
       throws Exception, IOException 
  {
      Hashtable ht = new Hashtable();
      sys.globalValues(ht,unum);

      String fieldNames = "gslogin,firstname,midname,lastname,url";
      String queryProjection = fieldNames;
      dbUser u = new dbUser();

      if(allFields) 	{
	fieldNames = u.getFieldNames();
	queryProjection = "*";
      }
      ResultSet rs = u.records(queryProjection,"","lastname,firstname");
      Parser.parseHtml(templateFile, ht, out,  new RecordParser(rs, fieldNames));
  }

  //--------------------------------------------------------------------//
  // Browse a user
  //--------------------------------------------------------------------//  
  void browseUser (ServletOutputStream out, String unum, String templateFile, String gslogin) 
       throws Exception, IOException
  {
    if(gslogin.length() >= gUsers.MIN_LOGIN_NAME_LENGTH) {
      try {
	//Hashtable ht=dbUser.getFields( gslogin );
	Hashtable ht=sys.usr_cache.get(gslogin).getFields();
	String rcl=dbUser.findRestrictedList((String)ht.get("ACL"));
	sys.globalValues(ht,unum);
	ht.put("rcl",rcl);
	Parser.parseHtml(templateFile,ht , out);
      
      } catch(Exception e) {
	throw new Exception("<h2>ERROR at browsing user "+gslogin+": "+e.getMessage()+"</h2>");
      }
    } else {
      throw new Exception("<h2>ERROR:Illegal user login name '"+gslogin+"'.</h2>");
    }
  }

  //--------------------------------------------------------------------//
  // open new user page using frames
  //--------------------------------------------------------------------//  
  void newUserFrame  (ServletOutputStream out, String unum, String templateFile)
       throws  Exception, IOException
  {
      Hashtable ht= new Hashtable();
      sys.globalValues(ht,unum);
      ht.put("framecomm", "NEWRECORD");
      ht.put("gslogin", "__new___");
      ht.put("file", "new.html");
      Parser.parseHtml(templateFile, ht, out);
  }

  //--------------------------------------------------------------------//
  // open new user record form in a frame 
  //--------------------------------------------------------------------//  
  void newUserRecord(ServletOutputStream out, String unum, String templateFile) 
       throws Exception, IOException
  {
      Hashtable ht = dbUser.getEmptyFields();
      sys.globalValues(ht,unum);
      String rcl=dbUser.findRestrictedList("");
      ht.put("rcl",rcl);
      Parser.parseHtml(templateFile, ht, out);
  }

  //--------------------------------------------------------------------//
  // open the page to  edit an existing user
  //--------------------------------------------------------------------//  
  void editUserFrame (ServletOutputStream out, String unum, 
		      String templateFile, String gslogin)        
       throws Exception,IOException
  {
      Hashtable ht= new Hashtable();
      sys.globalValues(ht,unum);
      ht.put("framecomm", "EDITRECORD");
      ht.put("gslogin", gslogin);
      ht.put("file", "edit.html");
      Parser.parseHtml(templateFile, ht, out);
  }
  //--------------------------------------------------------------------//
  //  editUserRecord page
  //--------------------------------------------------------------------//  
  void editUserRecord (ServletOutputStream out, String unum, 
		       String templateFile, String gslogin)        
       throws  Exception, IOException
  {
    //Hashtable ht=dbUser.getFields(gslogin);
    Hashtable ht=sys.usr_cache.get(gslogin).getFields();
      sys.globalValues(ht,unum);
      String rcl=dbUser.findRestrictedList((String)ht.get("ACL"));
      ht.put("rcl",rcl);
      Parser.parseHtml(templateFile, ht, out);
  }

  //--------------------------------------------------------------------//
  // DELETE a user
  //--------------------------------------------------------------------//  
  void deleteUser (ServletOutputStream out, String unum,
		   String templateFile, String gslogin, String answer) 
       throws Exception, IOException
  {
      Hashtable ht = new Hashtable();
      sys.globalValues(ht,unum);
      if(answer == null) {
	int pos=templateFile.lastIndexOf( (int) '/');
	templateFile=templateFile.substring(0,pos)+"/confirm.html";
	ht.put("message", "<br>Do you really want to delete the user <i>"+gslogin+"</i>?");
	ht.put("actionurl", "updatemessage.html");
	ht.put("comm","DELETE");	
	ht.put("gslogin",gslogin);
      } 
      else if(answer.equals("YES")) {
	//dbUser.delete(gslogin);
	sys.usr_cache.delete(gslogin);
	ht.put("message", "User information has been succesfully deleted!");
      }
      else if(answer.equals("NO")) {
	out.println("<script language=JavaScript> history.go(-2);</script>");
      }
      Parser.parseHtml(templateFile, ht, out);
      
  }

  //--------------------------------------------------------------------//
  // add new User
  //--------------------------------------------------------------------//  
  void addUser(ServletOutputStream out, String unum, dbUser dbu, String templateFile )
       throws Exception,IOException
  {
    try {
      if (dbStudent.existence(dbu.gslogin) )
	throw new Exception("unique");
      Hashtable ht = new Hashtable();
      sys.globalValues(ht,unum);
      //dbu.add();
      sys.usr_cache.add(dbu);
      ht.put("message", "User addition comleted successfully!");
      ht.put("reload","YES");
      ht.put("framecomm", "SHOW");
      ht.put("gslogin", dbu.gslogin);
      ht.put("file", "browse.html");
      Parser.parseHtml(templateFile, ht, out);
      try {Runtime.getRuntime().exec(sys.htpasswd+" "+sys.pwdfile+" " +dbu.gslogin+ " "+dbu.fields.get("gspwd" ));} catch( Exception e ) {}

    } catch( Exception e ) {
      String error =e.getMessage();
      if (error.indexOf("unique") >=0) {
	error= new String("This user login id exists in the system. <br> Please try another one.");
	}
      throw new Exception(error);
    }    
  }
  //--------------------------------------------------------------------//
  // update user record 
  //--------------------------------------------------------------------//  

  void updateUser(ServletOutputStream out, String unum, dbUser dbu,String templateFile)
       throws Exception,IOException
    {
      try {
	if (dbStudent.existence(dbu.gslogin) )
	  throw new Exception("unique");
	Hashtable ht = new Hashtable();
	sys.globalValues(ht,unum);
	//	dbu.update();
	sys.usr_cache.update(dbu);
	ht.put("message", "User update completed successfully!");
	ht.put("reload","YES");
	ht.put("framecomm", "SHOW");
	ht.put("gslogin", dbu.gslogin);
	ht.put("file", "browse.html");
	Parser.parseHtml(templateFile, ht, out);
	try {Runtime.getRuntime().exec(sys.htpasswd+" "+sys.pwdfile+" " +dbu.gslogin+ " "+dbu.fields.get("gspwd" ));} catch( Exception e ) {}
      } catch( Exception e ) {
	out.println( Html.header("User Records") );
	String error =e.getMessage();
	if (error.indexOf("unique") >=0) {
	  error= new String("This user login id exists in the system. <br> Please try another one.");
	}
	throw new Exception(error);
      }   
    }
  //--------------------------------------------------------------------//
  // 
  //--------------------------------------------------------------------//  
  void skip(ServletOutputStream out, String unum,String templateFile) 
       throws Exception,IOException
  {
      int pos=templateFile.lastIndexOf( (int) '/');
      templateFile=templateFile.substring(0,pos)+"/info.html";
      Hashtable ht = new Hashtable();
      sys.globalValues(ht,unum);
      Parser.parseHtml(templateFile,ht,out);
  }
  //--------------------------------------------------------------------//
  // info page
  //--------------------------------------------------------------------//  
  void infoPage(ServletOutputStream out, String unum,String templateFile) 
       throws Exception,IOException
  {
      Hashtable ht = new Hashtable();
      sys.globalValues(ht,unum);
      Parser.parseHtml(templateFile,ht,out);
  }
  //--------------------------------------------------------------------//
  // 
  //--------------------------------------------------------------------//  
  void  decideFrame(ServletOutputStream out, String unum ,String path,
		    String  framecomm, String file, String gslogin) 
       throws  Exception,IOException
  {
    //  try {
    Hashtable ht = new Hashtable();
    sys.globalValues(ht,unum);
    ht.put("framecomm", framecomm);
    ht.put("file", file);
    ht.put("gslogin",gslogin);
    Parser.parseHtml(path,ht,out);
    //  } catch( Exception e ) {
    //e.printStackTrace();
    //out.println( Html.header("User Records") );
    //String error =e.getMessage();
    //out.println("<h2>ERROR: "+error+" at guser.frame");
    //out.println("<HR>");
    //out.println( Html.footer() );
    //}   
  }


} //class close

