package gs.cache;

import java.util.Hashtable;
import java.io.IOException;

import gs.db.dbAssignment;



public class AssignmentCache {
  static int miss=0;
  static int hit=0;
  public static int size=30;
  static Hashtable assignmentht=new Hashtable(size);  //assignid, assignment
  static Hashtable index=new Hashtable(size);   //Integer,accesscode
  static int counter=0;


  public AssignmentCache(){  }
 //--------------------------------------------------------------------//
  // LOAD putIntoCache
  //--------------------------------------------------------------------//
  public static void clear(){
    assignmentht.clear();
    index.clear();
    counter =0;
  }
  public synchronized static  void putIntoCache(String assignidcourse , dbAssignment s){
    try {
      String REMOVE=Integer.toString(counter);
      index.remove(REMOVE);
      String oldkey=(String)index.get(REMOVE);
      assignmentht.remove(oldkey); 
    }
    catch (Exception e) {//System.out.println(" not existing");
    } 
    index.put(Integer.toString(counter),assignidcourse);
    assignmentht.put(assignidcourse,s);

    counter++;
    counter%=size;
  }

   
//--------------------------------------------------------------------//
  //dbAssignment revert                                      REVERT 
  //--------------------------------------------------------------------//
  public  static void  revert( String assignid,String course)    throws Exception , IOException 
  {

    dbAssignment s= (dbAssignment)assignmentht.get(assignid);
    if (s!=null) {
      assignmentht.remove(assignid); 
    }
  }

  //--------------------------------------------------------------------//
  //dbAssignment get( String assignid)                 GET 
  //--------------------------------------------------------------------//
  public  synchronized static dbAssignment get( String assignid,String course)    throws Exception , IOException 
  {
    dbAssignment u= (dbAssignment)assignmentht.get(assignid+course);
    if (u==null) {
      try {
	//System.out.println("assignid=========="+assignid);
	u= new dbAssignment(assignid,course);
	//System.out.println("assignid=========="+assignid);
	putIntoCache(assignid+course,u); 
	miss++;
      } catch (Exception e) {
	//System.out.println("Cache returning error for assignid"+assignid);
	throw e;
      }
    } else {
      hit++;
    }
    //System.out.println("==========assignment=============");
    //System.out.println("MISS "+miss+ " HIT "+hit);
    return u;
  }







  //--------------------------------------------------------------------//
  //--------------------------------------------------------------------//
  //--------------------------------------------------------------------//
  //--------------------------------------------------------------------//


  //--------------------------------------------------------------------//
  // delete assignment
  //--------------------------------------------------------------------//  
 
  public static void  delete(String assignid,String course)  throws Exception
  {
    dbAssignment.delete(assignid,course);
    assignmentht.remove(assignid+course);
  }
  //--------------------------------------------------------------------//
  // add assignment
  //--------------------------------------------------------------------//  
 
  public static void  add(dbAssignment dbu)  throws Exception
  {
    dbu.add();
    assignmentht.put(dbu.assignid+dbu.course,dbu);
  }
  //--------------------------------------------------------------------//
  // update assignment
  //--------------------------------------------------------------------//  
 
  public static void  update(dbAssignment dbu)  throws Exception
  {
    assignmentht.remove(dbu.assignid+dbu.course);
    dbu.setIdentification();
    dbu.update();
    assignmentht.put(dbu.assignid+dbu.course,dbu);
  }

}






