package gs.db;

import gs.db.database;
import gs.db.query;
import java.util.Hashtable;
import java.sql.ResultSet;

public class dbAssignment extends database {

  public       String assignid;          // unique key
  public       String course;

  
  static       String tablename="assignments";
  public dbAssignment() {}
  public dbAssignment(String course) { this.course=course;}
  public dbAssignment( String assignid,String course )        throws Exception
  {
    String queryString = "SELECT * from "+ getTableName() +
       " WHERE assignid ="+ assignid +" AND course='"+course+"'";
  try {
      //System.out.println("dbAssignment:queryString:"+queryString);
      ResultSet rs = query.queryData( queryString );
      if( rs.next() )
	{
	  fields.put("assignid", Integer.toString(rs.getInt("assignid")));
	  fields.put("course", (String)rs.getString("course"));
	  fields.put("type", (String)rs.getString("type"));	
	  fields.put("grbase", (String)rs.getString("grbase")); 
	  fields.put("weight", (String)rs.getString("weight")); 
	  fields.put("partials", (String)rs.getString("partials")); 
	  fields.put("publish", (String)rs.getString("publish")); 
	  fields.put("url", (String)rs.getString("url")); 
	  fields.put("commenturl", (String)rs.getString("commenturl")); 
	  fields.put("notes", (String)rs.getString("notes")); 
	  setIdentification();
	} else {
	 
	  throw new Exception("GS:dbAssignment:AssignmentNotFound: Assignment could not be found.(dbAssignment)");
	}
    } catch(Exception e) {
      //e.printStackTrace();
      throw e;
    }
  }
  //--------------------------------------------------------------------.// 
  public void setIdentification(){
     this.assignid     = (String) fields.get("assignid");
     this.course     = (String)fields.get("course"); 
  }

 

  //--------------------------------------------------------------------.// 
  public static String checkAssignmentID (String id) throws Exception {
    String queryString = "SELECT assignid from "+ tablename +
       " WHERE type ='"+ id +"'";
    try {
      ResultSet rs = query.queryData( queryString );
      //System.out.println("dbAssignment:queryString:checkAssignmentID:"+queryString);
      if( rs.next() )
	{
	  return (String)rs.getString("assignid");
	} else {
	  return null;
	}
    } catch(Exception e) {
      //e.printStackTrace();
      throw e;
    }
  }

  //--------------------------------------------------------------------.// 

  public  int findMaxAI() throws Exception
  {
    int max=0;
    int qn;
    ResultSet rs=records("assignid","course='"+course+"'","");

    while (rs.next()){
      qn=rs.getInt("assignid");
      if (qn>max) max=qn;
    }
      
    return max;
  }
 
  public String gradingBase(){
    if (fields.get("grbase")!=null)
      return (String)fields.get("grbase");
    return "";
  }
 

  //--------------------------------------------------------------------//
  //--------------------------------------------------------------------//
  //--------------------------------------------------------------------//
  //--------------------------------------------------------------------//
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  public   ResultSet listAssignments( boolean allFields) throws Exception
  {
      String queryProjection ="assignid,type,publish,url,commenturl";
      if(allFields) 	{
	queryProjection = "*";
      }
      return records(queryProjection,"course='"+course+"'","assignid");
  }
  public     String  listAssignmentsFields(boolean allFields ) throws Exception
  {
    if(allFields) 	
      return getFieldNames();
    return "assignid,type,publish,url,commenturl";
  }
  

  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  public  ResultSet classList(String course) throws Exception
  {

    String fieldNames = "weight,grbase,lastname,email,url,commenturl";
    String queryProjection = fieldNames;
    ResultSet rs = records(queryProjection,"course='"+course+"'", "lastname,lastname");
    return rs;
  }
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  public    String  classListFields(String course) throws Exception
  {
    return "weight,grbase,lastname,email,url,commenturl";
  }
 
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  public  ResultSet classPasswordList(String course) throws Exception
  {

    String fieldNames = "assignid,weight,grbase,lastname,email,url,systemslogin,notes";
    String queryProjection = fieldNames;
    ResultSet rs = records(queryProjection,"course='"+course+"'", "lastname,firstname");
    return rs;
  }
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  public    String  classPasswordListFields(String course) throws Exception
  {
    return "assignid,weight,grbase,lastname,email,url,systemslogin,notes";
  }
    
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  public String  majordomoList(String course, String []emails) throws Exception
  {
    
emails[0]="";
emails[1]="";
emails[2]="";
    String fieldNames = "weight,grbase,lastname,email,systemslogin";
    String queryProjection = fieldNames;
    ResultSet rs = records(queryProjection,"course='"+course+"'", "lastname,firstname");
    while (rs.next()){
      if (((String)rs.getString("systemslogin")).equals(""))
	emails[1]+=(String)rs.getString("weight")+" "+(String)rs.getString("grbase")+" "+(String)rs.getString("lastname")+"<br>";
      else if (((String)rs.getString("email")).equals(""))
	emails[2]+=(String)rs.getString("weight")+" "+(String)rs.getString("grbase")+" "+(String)rs.getString("lastname")+"<br>";
      else
	emails[0]+=(String)rs.getString("email")+",";
    
      course +=course;
    }
    return course;
  }
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  public    String  majordomoListFields(String course) throws Exception
  {
    return "assignid,weight,grbase,lastname,email,url,systemslogin,notes";
  }
    
  public String postOffice(String course) throws Exception {
    String queryString = "SELECT weight, grbase, lastname,email,url,commenturl  from "+ tablename +
      " WHERE course = '"+course +"' ORDER BY lastname,firstname";
    String out="";
    try {
      ResultSet rs = query.queryData( queryString );
      while (rs.next() ) {
	String commenturl=(String)rs.getString("commenturl");
	String url=(String)rs.getString("url");
	String name=(String)rs.getString("weight")+" "+ (String)rs.getString("grbase")+" "+  (String)rs.getString("lastname");
	
	  out+="recipient[n++] = new Recipient('"+name +"' ";
	  out+=",'Assignments'";
	  out+=",'"+url+"'";
	  out+=",'"+commenturl+"'"; 
	  out+=",'"+ (String)rs.getString("email")+"');";
      }
    }catch(Exception e) {
      //e.printStackTrace();
      throw e;
    }
    //System.out.println("out++>"+out+" course"+course);
    return out;
  }


  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  public static Hashtable getFields(String assignid,String course)  throws Exception
  {
    return new dbAssignment(assignid,course).getFields(); // super class' method
  }

  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  public static Hashtable getEmptyFields()
       throws Exception
  {
    Hashtable result = new Hashtable();
    result.put("assignid", "");
    result.put("course", "");
    result.put("type", ""); 
    result.put("weight", ""); 
    result.put("grbase", "");
    result.put("partials", ""); 
    result.put("publish", ""); 
    result.put("url", ""); 
    result.put("commenturl", ""); 
    result.put("notes","" ); 

    return result;
  }

  public String getTableName()
  {
    return tablename;
  }
  //<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  // used in SQL INSERT command
  public String getFieldNames()
  {
    return "assignid,course,"+
      "type,"+
      "weight,grbase,partials,publish,"+
      "url,commenturl,"+
      "notes";
  }

  // used in SQL INSERT command
  public String getFieldValues()
  {
    return                           ""+ 
      (String)fields.get("assignid")          +",'"+ 
      (String)fields.get("course")            +"','"+ 
      (String)fields.get("type")              +"','"+
      (String)fields.get("weight")        +"','"+
      (String)fields.get("grbase")          +"','"+ 
      (String)fields.get("partials")              +"','"+ 
      (String)fields.get("publish")              +"','"+ 
      (String)fields.get("url")              +"','"+ 
      (String)fields.get("commenturl")           +"','"+
      (String)fields.get("notes")         +"'";
  }

  //>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>

  // used in SQL UPDATE command
  public String getSetValues()
  {
    return "assignid="          + (String)fields.get("assignid")
      +",course='"              + (String)fields.get("course") 
      +"',type='"          + (String)fields.get("type") 
      +"',weight='"          + (String)fields.get("weight") 
      +"',grbase='"            + (String)fields.get("grbase") 
      +"',partials='"                + (String)fields.get("partials") 
      +"',publish='"                + (String)fields.get("publish") 
      +"',url='"                + (String)fields.get("url") 
      +"',commenturl='"             + (String)fields.get("commenturl") 
      +"',notes='"           + (String)fields.get("notes")
      +"'";
  }
  //_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
  //            OPERATIONS
  // \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  //CONSIDER LATER
  public String updateSQL()   throws Exception  {
    String oldassignid=(String)fields.get("oldassignid");
    if (!oldassignid.equals(assignid)) {
      String updatestr=" SET assignid="+assignid+" WHERE  course='"+course+"' and assignid="+oldassignid+"";
      update.updateData( "UPDATE grades "+updatestr);
    }
 
   return updateSQL("assignid="+oldassignid  +" AND course='"+course+"'");
  }
  public void update()throws Exception {
    //  try {
      update.updateData( updateSQL() );
      // }  catch (Exception e) {
      //  if 
      //  }
      
  }

  public static void  delete(String _assignid,String _course) throws Exception{
    String sqlcommand=new dbAssignment().deleteSQL("assignid="+ _assignid +" AND course='"+_course+"'");
    update.updateData(sqlcommand );
  }
  //CONSIDER LATER
  // public String deleteSQL() {
  //   return deleteSQL("assignid="+ assignid +"");
  // }

  public void add()throws Exception {
      update.updateData( insertSQL() );
  }

}







