package gs.db;


import gs.db.database;
import gs.db.query;
import java.util.Hashtable;
import java.sql.ResultSet;
import java.util.Enumeration ;
public class dbGrade extends database {

  public       String accesscode;          // unique key
  public       String assignid;          // unique key
  public       String course;
  private     boolean instructor=false;
  
  static       String tablename="grades";
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  public dbGrade() {}
   public dbGrade(String course) { this.course=course;}
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  public dbGrade(String course,String assignid ) { 
    this.course=course;
    this.assignid     =assignid;
  }
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  public dbGrade( String accesscode, String assignid,String course )        throws Exception
  {
    String queryString = "SELECT * from "+ getTableName() +
       " WHERE accesscode='"+accesscode+"' AND assignid ="+ assignid +" AND course='"+course+"'";
  try {
      //System.out.println("dbGrade:queryString:"+queryString);
      ResultSet rs = query.queryData( queryString );
      if( rs.next() )
	{
	  fields.put("accesscode", Integer.toString(rs.getInt("accesscode")));
	  fields.put("assignid", Integer.toString(rs.getInt("assignid")));
	  fields.put("course", (String)rs.getString("course"));
	  fields.put("grade", (String)rs.getString("grade"));	
	  fields.put("egrade", (String)rs.getString("egrade")); 
	  fields.put("partials", (String)rs.getString("partials")); 
	  fields.put("comment", (String)rs.getString("comment")); 
	  fields.put("tacomment", (String)rs.getString("tacomment")); 
	  String sc=(String)rs.getString("secretcomment");
	  if (sc==null) sc="";
	  fields.put("secretcomment", sc); 
	  setIdentification();
	} else {
	 
	  throw new Exception("GS:dbGrade:GradeNotFound: Grade could not be found.(dbGrade)");
	}
    } catch(Exception e) {
      //e.printStackTrace();
      throw e;
    }
  }
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  public void setIdentification(){
     this.assignid     = (String) fields.get("assignid");
     this.course     = (String)fields.get("course"); 
     this.accesscode     = (String)fields.get("accesscode"); 
  }


  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  public static Hashtable getFields(String accesscode,String assignid,String course)  throws Exception
  {
    return new dbGrade(accesscode,assignid,course).getFields(); // super class' method
  }

  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  public static Hashtable getEmptyFields()
       throws Exception
  {
    Hashtable result = new Hashtable();
    result.put("assignid", "");
    result.put("course", "");
    result.put("grade", ""); 
    result.put("egrade", "");
    result.put("partials", ""); 
    result.put("comment", ""); 
    result.put("tacomment", ""); 
    result.put("secretcomment", ""); 

    return result;
  }

  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
   public String getTableName()
  {
    return tablename;
  }

  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  // used in SQL INSERT command
  public String getFieldNames()
  {
    if (instructor)
      return "accesscode,assignid,course,"+
	"grade,"+
	"egrade,partials,comment,"+
	"tacomment,secretcomment";
    else       return "accesscode,assignid,course,"+
	"grade,"+
	"egrade,partials,comment,"+
	"tacomment";

  }

  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  // used in SQL INSERT command
  public String getFieldValues()
  {
    
     if (instructor)
       return                           "'"+ 
      (String)fields.get("accesscode")            +"',"+ 
      (String)fields.get("assignid")          +",'"+ 
      (String)fields.get("course")            +"','"+ 
      (String)fields.get("grade")              +"','"+
      (String)fields.get("egrade")          +"','"+ 
      (String)fields.get("partials")              +"','"+ 
      (String)fields.get("comment")              +"','"+ 
      (String)fields.get("tacomment")              +"','"+ 
      (String)fields.get("secretcomment")           +"'";
     else   
       return               "'"+ 
      (String)fields.get("accesscode")            +"',"+ 
      (String)fields.get("assignid")          +",'"+ 
      (String)fields.get("course")            +"','"+ 
      (String)fields.get("grade")              +"','"+
      (String)fields.get("egrade")          +"','"+ 
      (String)fields.get("partials")              +"','"+ 
      (String)fields.get("comment")              +"','"+ 
      (String)fields.get("tacomment")              +"'";
 }

  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  // used in SQL UPDATE command
  public String getSetValues()
  {

    
     if (instructor)
    
    return "accesscode='"          + (String)fields.get("accesscode")
      +"',assignid="          + (String)fields.get("assignid")
      +",course='"              + (String)fields.get("course") 
      +"',grade='"          + (String)fields.get("grade") 
      +"',egrade='"            + (String)fields.get("egrade") 
      +"',partials='"                + (String)fields.get("partials") 
      +"',comment='"                + (String)fields.get("comment") 
      +"',tacomment='"                + (String)fields.get("tacomment") 
      +"',secretcomment='"             + (String)fields.get("secretcomment") 
      +"'";
    else       return "accesscode='"          + (String)fields.get("accesscode")
      +"',assignid="          + (String)fields.get("assignid")
      +",course='"              + (String)fields.get("course") 
      +"',grade='"          + (String)fields.get("grade") 
      +"',egrade='"            + (String)fields.get("egrade") 
      +"',partials='"                + (String)fields.get("partials") 
      +"',comment='"                + (String)fields.get("comment") 
      +"',tacomment='"                + (String)fields.get("tacomment") 
     +"'";

   }
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  //            OPERATIONS
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  //CONSIDER LATER
  public String updateSQL()   {
    return updateSQL("assignid="+assignid  +" AND course='"+course+"' AND accesscode='"+accesscode+"'");
  }
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
   public void update(boolean ins)throws Exception {
     this.instructor=ins;
      if (0==update.updateData(   updateSQL() )   ) {
	add(ins);
      }
   }
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
   public static void  delete(String _assignid,String _course) 
       throws Exception
  {
    String sqlcommand=new dbGrade().deleteSQL("assignid="+ _assignid +" AND course='"+_course+"'" );
    update.updateData(sqlcommand );
  }
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  //CONSIDER LATER
  // public String deleteSQL() {
  //   return deleteSQL("assignid="+ assignid +"");
  // }

  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
   public void add(boolean ins)throws Exception {
      this.instructor=ins;
      update.updateData( insertSQL() );
  }





  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//

  public  ResultSet  getStudentGrades(String secret,Hashtable fields) throws Exception
  {
    String queryString = "SELECT "+
      "assignid,grade ,egrade ,partials ,comment ";
    if (secret.equals("NONE"))
      queryString += ",tacomment ,secretcomment\n" ;
    else if (secret.equals("TA"))
      queryString += ",tacomment \n" ;
    queryString +=  "from grades where course='"+course+"' and accesscode='"+(String) fields.get("accesscode")+"' ORDER BY  assignid ";
    //System.out.println("grades queryString  "+queryString );
 

    return query.queryDataOpen( queryString );
  }
  public boolean fetchStudentGrade(ResultSet rs,String secret,Hashtable fields,String assignid, boolean hasRecord) throws Exception
  {
     int ai= Integer.parseInt(assignid);

     while (hasRecord && ai > rs.getInt("assignid") )
       hasRecord=rs.next();

     String s="";
    
     if ( hasRecord && ai== rs.getInt("assignid") ){
       fields.put("grade", (String)rs.getString("grade"));	
       fields.put("egrade", (String)rs.getString("egrade")); 
       fields.put("partials", (String)rs.getString("partials")); 
       fields.put("comment", (String)rs.getString("comment")); 
       if (secret.equals("NONE")) {
	 fields.put("tacomment", (String)rs.getString("tacomment")); 
	 String sc=(String)rs.getString("secretcomment");
	 if (sc==null) sc="";
	 fields.put("secretcomment",sc ); 
       }else if (secret.equals("TA")) {
	 fields.put("tacomment", (String)rs.getString("tacomment")); 
	 fields.put("secretcomment",s); 
       }else { fields.put("tacomment",s); fields.put("secretcomment",s); }
     } else {
       fields.put("grade",s);                      
       fields.put("egrade",s);         
       fields.put("partials",s);         
       fields.put("comment",s);          
       fields.put("tacomment",s);        
       fields.put("secretcomment",s);    
     }
     return hasRecord;
  }

 
  public  void getStudentGrade(String secret,Hashtable fields) throws Exception
  {
    String queryString = "SELECT "+
      "grade ,egrade ,partials ,comment ";
    if (secret.equals("NONE"))
      queryString += ",tacomment ,secretcomment\n" ;
    else if (secret.equals("TA"))
      queryString += ",tacomment \n" ;
    queryString +=  "from grades where course='"+course+"' and assignid="+assignid
      +" and accesscode='"+(String) fields.get("accesscode")+"'";
    //System.out.println("grades queryString  "+queryString );
    ResultSet rs = query.queryDataOpen( queryString );
    String s="";
    if (rs.next()){
	  fields.put("grade", (String)rs.getString("grade"));	
	  fields.put("egrade", (String)rs.getString("egrade")); 
	  fields.put("partials", (String)rs.getString("partials")); 
	  fields.put("comment", (String)rs.getString("comment")); 
	  if (secret.equals("NONE")) {
	    fields.put("tacomment", (String)rs.getString("tacomment")); 
	    String sc=(String)rs.getString("secretcomment");
	    if (sc==null) sc="";
	    fields.put("secretcomment",sc ); 
	  }else if (secret.equals("TA")) {
	    fields.put("tacomment", (String)rs.getString("tacomment")); 
	    fields.put("secretcomment",s); 
	  }else { fields.put("tacomment",s); fields.put("secretcomment",s); }
    } else {
      fields.put("grade",s);                      
      fields.put("egrade",s);         
      fields.put("partials",s);         
      fields.put("comment",s);          
      fields.put("tacomment",s);        
      fields.put("secretcomment",s);    
    }


  }

  public  ResultSet  openAssignmentGrades() throws Exception
  {

    query.Open();
    String queryString = "SELECT  s.accesscode, s.firstname, s.midname, s.lastname, s.email, s.class, s.dept, \n"+
      "a.url ,a.assignid ,a.grbase ,a.weight \n"+
      "from assignments a , students s \n"+
      "where a.course='"+course+"'  and s.course='"+course+
      "' \n and a.assignid="+assignid +" ORDER by s.lastname,s.firstname" ;
    
    //System.out.println("grades queryString  "+queryString );
    return  query.queryDataOpen( queryString );
  }
  public  void  closeAssignmentGrades( ) throws Exception {
    query.Close();
    
  }

  public    String  assignmentGradesFields() throws Exception  {
    return " accesscode, firstname, midname, lastname, email, class, dept,url ,assignid ,grbase ,weight";
 }

   //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  public  ResultSet assignments() throws Exception
  {
    String queryString = "SELECT  "+

"a.assignid,a.type, a.url ,a.commenturl  ,a.grbase ,a.weight, a.publish\n"+

"from  assignments a \n"+
"where a.course='"+course+"' ORDER BY assignid ";
    //System.out.println("grades queryString  "+queryString +"*****\n");
    ResultSet rs = query.queryDataOpen( queryString );
    return rs;
  }

  public String  assignmentsFields() throws Exception
  {
       return "assignid , type ,url,commenturl, grbase ,weight,publish";
 } 
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  public  ResultSet studentGrades(String accesscode,String secret) throws Exception
  {
    String queryString = "SELECT  g.accesscode,\n"+

"a.assignid,a.type, a.url ,a.commenturl  ,a.grbase ,a.weight, a.publish,\n"+
"g.grade ,g.egrade ,g.partials ,g.comment ";

    if (secret.equals("NONE"))
      queryString += ",g.tacomment ,g.secretcomment\n" ;
    else if (secret.equals("TA"))
      queryString += ",g.tacomment \n" ;
    
    queryString += 
"from grades g, assignments a \n"+
"where a.course= g.course  and g.course='"+course+"' " +
"and g.accesscode='"+accesscode+"' and a.assignid=g.assignid ";
    //System.out.println("grades queryString  *\n*\n"+queryString +"*****\n");
    ResultSet rs = query.queryDataOpen( queryString );
    return rs;
  }

  public String  studentGradesFields(String secret) throws Exception
  {
     if (secret.equals("NONE"))
       return "assignid , type ,url,commenturl, grbase ,weight,grade ,egrade ,partials ,comment ,tacomment ,secretcomment";
     else if (secret.equals("TA"))
       return "assignid , type ,url,commenturl, grbase ,weight,grade ,egrade ,partials ,comment ,tacomment ";

     return "";
 }
 


 

 //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//

  public String getSecretComment( String accesscode, String assignid,String course )        throws Exception
  {
    String queryString = "SELECT secretcomment  from "+ getTableName() +
      " WHERE accesscode='"+accesscode+"' AND assignid ="+ assignid +" AND course='"+course+"'";
    try {
      //System.out.println("dbGrade:queryString:"+queryString);
      ResultSet rs = query.queryData( queryString );
      if( rs.next() ) {
	String sc ="";
	sc=(String)rs.getString("secretcomment");	
        if (sc==null)
	  return "";
	else return sc;
      }
    } catch(Exception e) {}
    return "";
  }

 //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
//@@@@@@@@@@@@@@@@@@@@@@@@@
  public  boolean checkGradeCustomization()  throws Exception  {
    String queryString = "SELECT grdtype from courses where title='"+course+"'";
     //System.out.println("checkGradeCustomization queryString  "+queryString );
   ResultSet rs = query.queryDataOpen( queryString );
    if (rs.next() &&((String)rs.getString("grdtype")).equals("customized")) 
      return true;
    return false;

  }
//@@@@@@@@@@@@@@@@@@@@@@@@@
  public  String courseCustomizedGradesHtml()  throws Exception  {
    String gstr="";

	
	String queryString = "SELECT  grade,points from customizedgrades where course='"+course+"' ORDER BY points";
	//System.out.println("courseCustomizedGrades getCustomizedGrades queryString  "+queryString );
	ResultSet rs = query.queryDataOpen( queryString );    
	while (rs.next()){
	  gstr+="<option> "+(String)rs.getString("grade");        
	}	
	gstr+="</select>";

    return gstr;
  }
//@@@@@@@@@@@@@@@@@@@@@@@@@
  public  ResultSet getCustomizedGrades()  throws Exception  {
                    
    String queryString = "SELECT  grade,points from customizedgrades where course='"+course+"' ORDER BY points";
	//System.out.println("courseCustomizedGradesRS getCustomizedGrades queryString  "+queryString );
	 
	
    return  query.queryDataOpen( queryString );   
  }

//@@@@@@@@@@@@@@@@@@@@@@@@@
  public double  getCustomizedGradePairs(String course ,Hashtable ht ) throws Exception
  {
    String queryString = "SELECT  grade,points from customizedgrades where course='"+course+"' ORDER BY points";
    //System.out.println("grades getCustomizedGrades queryString  "+queryString );
    ResultSet rs = query.queryDataOpen( queryString );    
   double max=0;
    while (rs.next()){
      Double D=Double.valueOf((String)rs.getString("points"));
      double d=D.doubleValue();
      if (d>max) max=d;
      ht.put((String)rs.getString("grade"),D);        
      //System.out.println("points grade "+(String)rs.getString("grade") +"--> "+(String)rs.getString("points") );
    }
    ht.put("",Double.valueOf("0"));
    return max;
    
  }
 //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  String selectMaxSmall(Hashtable grd,double  average)throws Exception
  {
    String s="";
      double d=0;
    double maxsmall=0;
    Enumeration e=grd.elements();
    Enumeration ek=grd.keys();
    while (e.hasMoreElements()){
      String s1=(String)ek.nextElement();
      d=((Double)e.nextElement()).doubleValue();
      if (d>maxsmall && d<=average) {
	maxsmall=d;
	s=s1;
      }
    }
    return s;
  }

  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  public String calculateAverage(String accesscode,Hashtable ht) 
       throws Exception
  {
    ht.put("assigncount","unknown");

    String queryString = "SELECT  "+
"c.grdtype, c.extracredits,"+
"a.type ,a.grbase ,a.weight, a.publish, \n"+
"g.grade ,g.egrade ,g.partials ";
    queryString += 
"from grades g, assignments a, courses c  \n"+
"where c.title=a.course AND a.course=g.course AND g.course='"+course+"' " +
"and g.accesscode='"+accesscode+"' and a.assignid=g.assignid ";
    //System.out.println("grades queryString  "+queryString );
    ResultSet rs = query.queryData( queryString );
    
    int acount=0;
    int xcount=0;
    int pcount=0;
    double average=0;
    double maxNumeric=100;  //double maxBase=100;
    double grade=0;
    double grbase=0;
    double egrade=0;
    boolean weighted=false;
    boolean notweighted=false;
    double gradedWeight=0;

    boolean gradeTESTnull=false;
    boolean grbaseTESTnull=false;
    boolean egradeTESTnull=false;
    boolean weightTESTnull=false;

    boolean customized=false;
    boolean extra=false;
    Hashtable grd=new Hashtable();
    
   

  
   
    
    //    fields.put("assignid", Integer.toString(rs.getInt("assignid")));
    //  fields.put("course", (String)rs.getString("course"));

    while ( rs.next()) {
      if ( ((String)rs.getString("publish")).equals("NO"))
	continue;
      if (  !customized && ((String)rs.getString("grdtype")).equals("customized")) {
	customized=true;
	maxNumeric=getCustomizedGradePairs(course,grd);
      }
      
      if ( !extra && ((String)rs.getString("extracredits")).equals("YES"))
	extra=true;
      //System.out.println("'");//System.out.println("'");System.out.println("'");
      if (customized) {
	grade=((Double)grd.get((String)rs.getString("grade"))).doubleValue();
	grbase=((Double)grd.get((String)rs.getString("grbase"))).doubleValue();
	//System.out.println("(Double)grd.get((String)rs.getString(egrade) ["+ egrade+"]["+(String)rs.getString("egrade"));
	if (extra)
	  egrade=((Double)grd.get((String)rs.getString("egrade"))).doubleValue();
	
      }else {
	try {grade=(double)rs.getDouble("grade"); gradeTESTnull=rs.wasNull();} 
	catch ( Exception e) {gradeTESTnull=true;    }
	try {grbase=(double)rs.getDouble("grbase"); grbaseTESTnull=rs.wasNull();} 
	catch ( Exception e) {	grbaseTESTnull=true;    }
	if (extra) {
	  try { egrade=(double)rs.getDouble("egrade"); }  //0 default
	  catch ( Exception e) {	egrade=0;   }
	}
      }
      //System.out.println("***************************-------------- " );
      //System.out.println("average grade acount"+ average +" "+grade+" "+acount);
       if (gradeTESTnull)
	continue;
      if (grbaseTESTnull)
	grbase=100;
      //  if (egrade==egranull)
      //    egrade=0;
      //System.out.println("##################*CONTINUE " );
      //System.out.println("average grade acount"+ average +" "+grade+" "+acount);
      
      grade+=egrade;
      double weight=0;
      try {
	 weight=(double)rs.getDouble("weight"); weightTESTnull=rs.wasNull();
      } catch ( Exception e) {	weightTESTnull=true;    }
      // if (((String)rs.getString("weight")).equals(""))
      //	weightTESTnull=true;
      if (weightTESTnull ) {
	if ( weighted )
	  return "NAP w";
	//  throw new Exception("Average Not Applicaple; There are inconsistencies in weight fields; published assignment weights should be all filled or all empty.");
	notweighted=true;
      } else {
	if ( notweighted )
	  return "NAP W";
	weighted=true;
      }

      //System.out.println("-----------1--------------------------------------------- " );
      //System.out.println("average grade acount    "+ average +" "+grade+" "+acount);
      
      if (grbase==0)
	return "NAP:/0";
	//throw new Exception("Division by 0; grading base can not be 0");
      grade*=maxNumeric/grbase;
      //System.out.println("----------2-----------------------------------------maxNumeric---grbase-- " );
      //System.out.println("average grade acount    "+ average +" "+grade+" "+acount+" "+ maxNumeric+" "+grbase);
      if (weighted) {
	grade=grade*weight/100;
	gradedWeight+=weight;
      }
      
      average+=grade;
      acount++;
      //System.out.println("-----------3--------------------------------------------- " );
      //System.out.println("average grade acount   "+ average +" "+grade+" "+acount);
    }
    //System.out.println(" WHILE ENDS      ");
    //System.out.println("average grade acount   "+ average +" "+grade+" "+acount);
    String averageStr="NAP";
    if (acount!=0) {
      if (weighted)
	average*=100/gradedWeight;
      else average/=acount;
    }
   if (customized) {
     averageStr=selectMaxSmall(grd,average);
     //System.out.println("average  averageStr"+ average+"=="+averageStr);
     if (averageStr.equals("ABSENT") ||averageStr.equals("PRESENT") )
	 averageStr=Integer.toString((int)(average*100));
   } else {
     averageStr=Integer.toString((int)average);
   }

   if (weighted)
     ht.put("WEIGHTED","YES");
   else ht.put("WEIGHTED","NO");
   ht.put("assigncount",Integer.toString(acount));
   return averageStr;
     
 }
  public ResultSet  allGrades(String Assignment ) throws Exception {
    String queryString = "SELECT  grade "+
      "from grades  \n"+
      "where course='"+course+"' AND assignid="+Assignment+"  ORDER BY grade";
    //System.out.println("allGrades  queryString \n "+queryString );
   
    return query.queryData( queryString );
 
  }
   //--------------------------------------------------------------------.// 
  //-------------------------Performance---------------------------------.// 
 //--------------------------------------------------------------------.// 
   //--------------------------------------------------------------------.// 
  //-------------------------Performance---------------------------------.// 
 //--------------------------------------------------------------------.// 

  public ResultSet  allAverages( ) throws Exception {
    String queryString = "SELECT  average "+
      "from performances  \n"+
      "where course='"+course+"' AND  average <> 'NAP%' ORDER BY average";
    //System.out.println("allAverages  queryString \n "+queryString );
   
    return query.queryData( queryString );
 
  }
  public ResultSet  ranks( ) throws Exception {
    String queryString = "SELECT s.accesscode, s.firstname,s.midname,s.lastname, p.average "+
      "from performances p,students s  \n"+
      "where  p.course='"+course+"' AND s.accesscode=p.accesscode AND   p.average <> 'NAP%' ORDER BY p.average ";
    //System.out.println(" ranks queryString \n "+queryString );
   
    return query.queryData( queryString );
 
  }
  public void studentPerformance (String accesscode,Hashtable ht,String average)  throws Exception {
    
    String queryString = "SELECT  "+
      "finalgrade ,average ,remark ,taremark,secretremark ";
    queryString += 
      "from performances  \n"+
      "where course='"+course+"' " +
      "and accesscode='"+accesscode+"' ";
    //System.out.println("gradesPERFORMANCE  queryString  "+queryString );
    ResultSet rs = query.queryData( queryString );
    if (rs.next()) {
      String finalgrade= (String)rs.getString("finalgrade");
      if (finalgrade==null) finalgrade="";
      String   remark= (String)rs.getString("remark");
      if (remark==null) remark="";
      String   taremark= (String)rs.getString("taremark");
      if (taremark==null) taremark="";
      String secretremark=  (String)rs.getString("secretremark");
      if (secretremark==null) secretremark="";

      ht.put("finalgrade",finalgrade);
      ht.put("average",average);
      ht.put("remark",remark);
      ht.put("taremark",taremark);
      ht.put("secretremark",secretremark);
    } 
    else {
       ht.put("finalgrade",""); ht.put("average","");
       ht.put("remark","");ht.put("taremark","");
       ht.put("secretremark","");
    }
  }




  public void studentPerformanceReadSet (String accesscode,Hashtable ht,String dbcase)  
       throws Exception
  {
    String average=calculateAverage(accesscode,ht);
    if (dbcase.equals("WRITEAVERAGE")) {
      String updateString = "UPDATE performances  SET average='" +average
	+ "' WHERE  accesscode='"+accesscode+"' and course='"+course+"'";
      if (0==update.updateData( updateString )) {
	updateString = " INSERT INTO performances  (accesscode,course,average) VALUES ('"+accesscode+"','"+course+"','"+ average +"')";
	update.updateData( updateString );
      }
    }
    studentPerformance(accesscode,ht,average);	
  }
  public int calculateAllaverages()  
       throws Exception
  {
    int i=0;
     String queryString = "SELECT accesscode from students  where course='"+course+"' ";
     //System.out.println(" calculateAllaverages  queryString  "+queryString );
    ResultSet rs = query.queryDataOpen( queryString );   
    Hashtable ht=new Hashtable();
   
    while (rs.next()){
      String ac= (String)rs.getString("accesscode");
      i++; 
      String average=calculateAverage(ac,ht);
      String updateString = "UPDATE performances  SET average='" +average
	+ "' WHERE  accesscode='"+ac+"' and course='"+course+"'";
      if (0==update.updateData( updateString )) {
	updateString = " INSERT INTO performances  (accesscode,course,average) VALUES ('"+ac+"','"+course+"','"+ average +"')";
	update.updateData( updateString );
      }    
    }
    return i;
  }

  public void updatePerformance (boolean ins)  
       throws Exception
  {
    String av=(String) fields.get("average");
    String fg=(String) fields.get("finalgrade");
    String sr=(String) fields.get("secretremark");
    String tr=(String) fields.get("taremark");
    String r=(String) fields.get("remark");
    String c=(String) fields.get("course");
    String a=(String) fields.get("accesscode");
    if (ins) { 
      String updateString = "UPDATE performances  SET average='" +av+"', finalgrade='" +fg+"', secretremark='" +sr+"', taremark='" +tr+"', remark='" +r+"'  WHERE  accesscode='"+a+"' and course='"+c+"'";
      if (0==update.updateData( updateString )) {
	updateString = " INSERT INTO performances  (accesscode,course,average,finalgrade,remark,taremark,secretremark) VALUES ('"+a+"','"+c+"','"+ av+"','"+fg+"','"+r+"','"+tr+"','"+sr+"')";
	update.updateData( updateString );
      }
    } else {
      String updateString = "UPDATE performances  SET average='" +av+"', finalgrade='" +fg+"' ,taremark='" +tr+"' ,remark='" +r+"'  WHERE  accesscode='"+a+"' and course='"+c+"'";
      if (0==update.updateData( updateString )) {
	updateString = " INSERT INTO performances  (accesscode,course,average,finalgrade,remark,taremark) VALUES ('"+a+"','"+c+"','"+ av+"','"+fg+"','"+r+"','"+tr+"')";
	update.updateData( updateString );
      }

    }

  }

   //--------------------------------------------------------------------.// 
  //-------------------------Performance---END--------------------------.// 
 //--------------------------------------------------------------------.// 



 

  //--------------------------------------------------------------------.// 
  public static String checkGradeID (String id) throws Exception {
    String queryString = "SELECT assignid from "+ tablename +
       " WHERE grade ='"+ id +"'";
    try {
      ResultSet rs = query.queryData( queryString );
      //System.out.println("dbGrade:queryString:checkGradeID:"+queryString);
      if( rs.next() )
	{
	  return (String)rs.getString("assignid");
	} else {
	  return null;
	}
    } catch(Exception e) {
      //e.printStackTrace();
      throw e;
    }
  }

  //--------------------------------------------------------------------.// 

  public  int findMaxAI() throws Exception
  {
    int max=0;
    int qn;
    ResultSet rs=records("assignid","course='"+course+"'","");

    while (rs.next()){
      qn=rs.getInt("assignid");
      if (qn>max) max=qn;
    }
      
    return max;
  }
 
  public String gradingBase(){
    if (fields.get("egrade")!=null)
      return (String)fields.get("egrade");
    return "";
  }
 

  //--------------------------------------------------------------------//
  //--------------------------------------------------------------------//
  //--------------------------------------------------------------------//
  //--------------------------------------------------------------------//
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  public   ResultSet listGrades( boolean allFields) throws Exception
  {
      String queryProjection ="assignid,grade,comment,tacomment,secretcomment";
      if(allFields) 	{
	queryProjection = "*";
      }
      return records(queryProjection,"course='"+course+"'","assignid");
  }
  public     String  listGradesFields(boolean allFields ) throws Exception
  {
    if(allFields) 	
      return getFieldNames();
    return "assignid,grade,comment,tacomment,secretcomment";
  }
  

  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  public  ResultSet classList(String course) throws Exception
  {

    String fieldNames = "weight,egrade,lastname,email,tacomment,secretcomment";
    String queryProjection = fieldNames;
    ResultSet rs = records(queryProjection,"course='"+course+"'", "lastname,firstname");
    return rs;
  }
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  public    String  classListFields(String course) throws Exception
  {
    return "weight,egrade,lastname,email,tacomment,secretcomment";
  }
 
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  public  ResultSet classPasswordList(String course) throws Exception
  {

    String fieldNames = "assignid,weight,egrade,lastname,email,tacomment,systemslogin,notes";
    String queryProjection = fieldNames;
    ResultSet rs = records(queryProjection,"course='"+course+"'", "lastname,firstname");
    return rs;
  }
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  public    String  classPasswordListFields(String course) throws Exception
  {
    return "assignid,weight,egrade,lastname,email,tacomment,systemslogin,notes";
  }
    
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  public String  majordomoList(String course, String []emails) throws Exception
  {
    
emails[0]="";
emails[1]="";
emails[2]="";
    String fieldNames = "weight,egrade,lastname,email,systemslogin";
    String queryProjection = fieldNames;
    ResultSet rs = records(queryProjection,"course='"+course+"'", "lastname,firstname");
    while (rs.next()){
      if (((String)rs.getString("systemslogin")).equals(""))
	emails[1]+=(String)rs.getString("weight")+" "+(String)rs.getString("egrade")+" "+(String)rs.getString("lastname")+"<br>";
      else if (((String)rs.getString("email")).equals(""))
	emails[2]+=(String)rs.getString("weight")+" "+(String)rs.getString("egrade")+" "+(String)rs.getString("lastname")+"<br>";
      else
	emails[0]+=(String)rs.getString("email")+",";
    
      course +=course;
    }
    return course;
  }
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  public    String  majordomoListFields(String course) throws Exception
  {
    return "assignid,weight,egrade,lastname,email,tacomment,systemslogin,notes";
  }
  /*   
  public String postOffice(String course) throws Exception {
    String queryString = "SELECT weight, egrade, lastname,email,tacomment,secretcomment  from "+ tablename +
      " WHERE course = '"+course +"' ORDER BY lastname";
    String out="";
    try {
      ResultSet rs = query.queryData( queryString );
      while (rs.next() ) {
	String secretcomment=(String)rs.getString("secretcomment");
	String tacomment=(String)rs.getString("tacomment");
	String name=(String)rs.getString("weight")+" "+ (String)rs.getString("egrade")+" "+  (String)rs.getString("lastname");
	
	  out+="recipient[n++] = new Recipient('"+name +"' ";
	  out+=",'Grades'";
	  out+=",'"+tacomment+"'";
	  out+=",'"+secretcomment+"'"; 
	  out+=",'"+ (String)rs.getString("email")+"');";
      }
    }catch(Exception e) {
      //e.printStackTrace();
      throw e;
    }
    //System.out.println("out++>"+out+" course"+course);
    return out;
  }
  */
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//

  public void  surveyAnswers(Hashtable anw, String course,String surveyname) throws Exception
  {
    String queryString = "SELECT qid,answer FROM answers WHERE course='"+course+"' AND surveyname='"+surveyname+"'  ORDER BY qid ";
      //System.out.println("dbGrade:queryString::surveyAnswers"+queryString);
    
    ResultSet rs = query.queryData( queryString );
    /*
    while (rs.next() ) {
      String qa=(String)rs.getString("qid")+"A"+(String)rs.getString("answer");
      String I= (String)anw.get(qa) ;
      if ( I==null) I="|";
      else I+="|";
      anw.put(qa,I);
      System.out.println("qa " +qa +" I"+I);
    }  */ 
    while (rs.next() ) {
      String qa=(String)rs.getString("qid")+"A"+(String)rs.getString("answer");
      String I= (String)anw.get(qa) ;
      if ( I==null) I="1";
      else I=Integer.toString(Integer.parseInt(I)+1);
      anw.put(qa,I);
      //System.out.println("qa " +qa +" I"+I);
    }
   
    /*    while (rs.next() ) {
      String qa=(String)rs.getString("qid")+(String)rs.getString("answer");
      Integer I= Integer.parseInt( (String)anw.get(qa));
      if ( I==null) I=new Integer(1);
      else I=new Integer(I.getValue()+1);
      anw.put(qa,I);
    }*/
  }
   
}







