package gs.db;

//import gs.object.aUser;
import gs.db.database;
import gs.db.query;
import java.util.Hashtable;
import java.sql.ResultSet;

public class dbQuestion extends database {

  public       String qid;          // unique key

  public  static String tablename="questions";
  public  static String fieldnames="qid,question,category";
  public dbQuestion() {}
  public dbQuestion( String qid )        throws Exception
  {
    String queryString = "SELECT * from "+ getTableName() +
       " WHERE qid ="+ qid ;
  try {
      ResultSet rs = query.queryData( queryString );
      //System.out.println("dbQuestion:queryString:"+queryString);
      if( rs.next() )
	{
	  fields.put("qid",  Integer.toString(rs.getInt("qid")));
	  fields.put("question", (String)rs.getString("question"));
	  fields.put("category", (String)rs.getString("category")); 

	  setIdentification();
	} else {
	 
	  throw new Exception("dbQuestion:QuestionNotFound: Question could not be found.(dbQuestion)");
	}
    } catch(Exception e) {
      //e.printStackTrace();
      throw e;
    }
  }
  public dbQuestion( String qn,String question,String category){
 	  fields.put("qid", qn);
	  fields.put("question", question);
	  fields.put("category", category); 
	  setIdentification();   
  }
  public void setIdentification(){

     this.qid     = (String) fields.get("qid");
  }
 
  public static Hashtable getFields(String qid)  throws Exception
  {
    return new dbQuestion(qid).getFields(); // super class' method
  }

  public static Hashtable getEmptyFields()
       throws Exception
  {
    Hashtable result = new Hashtable();
    result.put("qid",	""); 
    result.put("question",	""); 
    result.put("category",	""); 

    return result;
  }

  public String getTableName()
  {
    return tablename;
  }
  public  int findMaxQN() throws Exception
  {
    int max=0;
    int qn;
    ResultSet rs=records("qid","","");

    while (rs.next()){
      qn=rs.getInt("qid");
      if (qn>max) max=qn;
    }
      
    return max;
  }
 
  //<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  // used in SQL INSERT command
  public  String getFieldNames()
  {
    return fieldnames;
  }

  // used in SQL INSERT command
  public String getFieldValues()
  {
    return                           ""+ 
      (String)fields.get("qid")	+",'"+ 
      (String)fields.get("question")	+"','"+ 
      (String)fields.get("category")	
			 +"'";
  }

  //>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>

  // used in SQL UPDATE command
  public String getSetValues()
  {
    return "qid="          + (String)fields.get("qid")
      +",question='"              + (String)fields.get("question")
      +"',category='"              + (String)fields.get("category") 
      +"'";
  }
  //_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
  //            OPERATIONS
  // \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \

  //CONSIDER LATER
  public String updateSQL()   {
    return updateSQL("qid="+qid  +"");
  }
  public void update()throws Exception {
      update.updateData( updateSQL() );
  }

  public static void  delete(String _qid) throws Exception{
    String sqlcommand=new dbQuestion().deleteSQL("qid="+ _qid +"");
    update.updateData(sqlcommand );
  }
  public static void  deleteList(String list) throws Exception{
    // System.out.println("LIST"+list);
    String sqlcommand=new dbQuestion().deleteSQL(list);
    update.updateData(sqlcommand );
  }
  //CONSIDER LATER
  public String deleteSQL() {
    return deleteSQL("qid="+ qid +"");
  }

  public void add()throws Exception {
    try {
      update.updateData( insertSQL() );
    } catch (Exception e) {
      update();
    }
  }

}







